unit Api;



interface
uses Sysutils,Dialogs,odbc_api,odbctype, winprocs, wintypes, sockio;


type TBoundCols = record
hstmt : SQLHSTMT;
colno : SQLUSMALLINT;
RemoteAddr : Pointer;
RemoteLenAddr : Pointer;
MaxSize : Longint;
Localptr : Pchar;
CurrSize : SQLINTEGER;
str : integer;
end;
var
BoundCols : array [1..512] of TBoundCols;
function getinfotype(infotype : SQLUSMALLINT) : boolean;
procedure UpdateColBuffs(hstmt : SQLHSTMT);
procedure FreeColBinds( hstmt : SQLHSTMT);
function GetDefaultType(dt : SQLSMALLINT) : Integer;
function GetLocalPtr(hstmt : SQLHSTMT; cno : SQLUSMALLINT) : Integer;
function GetRemoteAddr(LocalPtr : Pchar) : Pchar;
function GetFreeBind : Integer;
function GetOldBind(hstmt : SQLHSTMT ; cno : SQLUSMALLINT) : Integer;
procedure Gethandle(var hdbc : SQLHDBC; pno : integer);

procedure callSQLAllocEnv;
procedure callSQLFreeEnv;
procedure callSQLAllocConnect;
procedure callSQLConnect;
procedure callSQLDisconnect;
procedure callSQLFreeConnect;
procedure callSQLGetInfo;
procedure callSQLAllocStmt;
procedure callSQLFreeStmt;
procedure callSQLGetTypeInfo;
procedure callSQLNumResultCol;
procedure callSQLDescribeCol;
procedure callSQLBindCol;
procedure callSQLFetch;
procedure callSQLTables;
procedure callSQLError;
procedure callSQLGetFunctions;
procedure callSQLTransact;
procedure callSQLGetConnectOption;
procedure callSQLSetConnectOption;
procedure callSQLDriverConnect;
procedure callSQLColumns;
procedure callSQLSpecialColumns;
procedure callSQLColAttributes;
procedure callSQLStatistics;
procedure callSQLSetStmtOption;
procedure callSQLGetStmtOption;
procedure callSQLExecDirect;
procedure callSQLRowCount;
procedure callSQLCancel;



implementation
uses Main, options;


procedure callSQLAllocEnv;
var
envh : SQLHENV;
begin

     envh := 0;
     Sockfd.FuncResult := SQLAllocEnv(envh);
     Sockfd.ParamStack[1].plen := sizeof(envh);
     MemMove(Sockfd.ParamStack[1].pbuff,@envh,sizeof(envh));

end;


procedure callSQLFreeEnv;
var
envh : SQLHENV;
begin

     GetHandle(envh,1);
     Sockfd.FuncResult := SQLFreeEnv(envh);
end;

procedure callSQLAllocConnect;
var
henv : SQLHENV;
hdbc : SQLHDBC;
begin

     hdbc := 0;
     GetHandle(henv,1);
     Sockfd.FuncResult := SQLAllocConnect(henv,hdbc);
     Sockfd.ParamStack[2].plen := sizeof(hdbc);
     MemMove(Sockfd.ParamStack[2].pbuff,@hdbc,sizeof(hdbc));

end;

procedure callSQLFreeConnect;
var
hdbc : SQLHDBC;
begin
     GetHandle(hdbc,1);
     Sockfd.FuncResult := SQLFreeConnect(hdbc);
end;

procedure callSQLConnect;
var
hdbc : SQLHDBC;
l1,l2,l3 : SQLSMALLINT;
sptr,stptr,tptr : PChar;
slen,tlen : SQLSMALLINT;
begin
     Gethandle(hdbc,1);
     MemMove(@l1,Sockfd.ParamStack[3].pbuff,sizeof(l1));
     MemMove(@l2,Sockfd.ParamStack[5].pbuff,sizeof(l2));
     MemMove(@l3,Sockfd.ParamStack[7].pbuff,sizeof(l3));
     Sockfd.FuncResult :=
     SQLConnect(hdbc,
                Sockfd.ParamStack[2].pbuff,l1,
                Sockfd.ParamStack[4].pbuff,l2,
                Sockfd.ParamStack[6].pbuff,l3);


     if Sockfd.FuncResult = 0 then
     begin

          GetMem(tptr,1024);
          SQLGetInfo(hdbc,2,tptr,1023,tlen);
          Form1.Edit1.Text := StrPas(tptr);
          FreeMem(tptr,1024);
     end;


end;

procedure callSQLDisconnect;
var
hdbc : SQLHDBC;
begin
      GetHandle(hdbc,1);
      Sockfd.FuncResult := SQLDisconnect(hdbc);
      if Sockfd.FuncResult = 0 then form1.edit1.text := '';
end;

procedure callSQLGetInfo;
var
hdbc : SQLHDBC;
infotype : SQLUSMALLINT;
infomaxvalue : SQLSMALLINT;
slen : SQLSMALLINT;
flag: boolean;
pch : Pchar;
begin


     slen := 0;
     Gethandle(hdbc,1);
     MemMove(@infotype,Sockfd.ParamStack[2].pbuff,sizeof(infotype));
     MemMove(@infomaxvalue,Sockfd.ParamStack[4].pbuff,sizeof(infomaxvalue));

     Sockfd.FuncResult := SQLGetInfo(hdbc,infotype,
     Sockfd.ParamStack[3].pbuff,infomaxvalue,
     slen);
     Sockfd.ParamStack[5].plen := sizeof(slen);
     Sockfd.ParamStack[3].plen := slen;

     pch := Sockfd.ParamStack[3].pbuff;
     flag := getinfotype(infotype);

    if flag then
    begin
    Sockfd.ParamStack[3].plen := Sockfd.ParamStack[3].plen + 1;
    (pch+slen)^ := #0;
    end;

    MemMove(Sockfd.ParamStack[5].pbuff,@slen,sizeof(slen));

end;

procedure callSQLAllocStmt;
var
hdbc : SQLHDBC;
hstmt : SQLHSTMT;
begin

     GetHandle(hdbc,1);
     Sockfd.FuncResult := SQLAllocStmt(hdbc,hstmt);
     MemMove(Sockfd.ParamStack[2].pbuff,@hstmt,sizeof(hstmt));
     Sockfd.ParamStack[2].plen := sizeof(hstmt);

end;

procedure callSQLFreeStmt;
var
hstmt : SQLHSTMT;
opt : SQLUSMALLINT;
begin


     GetHandle(hstmt,1);
     MemMove(@opt,Sockfd.ParamStack[2].pbuff,sizeof(opt));
     Sockfd.FuncResult := SQLFreeStmt(hstmt,opt);

     if (opt = 1) or (opt = 2)  then
     FreeColBinds(hstmt);

end;


procedure callSQLGetTypeInfo;
var
hstmt : SQLHSTMT;
ftype : SQLSMALLINT;
begin
     Gethandle(hstmt,1);
     MemMove(@ftype,Sockfd.ParamStack[2].pbuff,sizeof(ftype));
     Sockfd.FuncResult := SQLGetTypeInfo(hstmt,ftype);
end;


procedure callSQLNumResultCol;
var
hstmt : SQLHSTMT;
noc : SQLSMALLINT;
begin

     Gethandle(hstmt,1);
     Sockfd.FuncResult := SQLNumResultCols(hstmt,noc);
     MemMove(Sockfd.ParamStack[2].pbuff,@noc,sizeof(noc));
     Sockfd.ParamStack[2].plen := sizeof(noc);

end;

procedure callSQLDescribeCol;
var
hstmt : SQLHSTMT;
colnum : SQLUSMALLINT;
cnamemax : SQLSMALLINT;
NameLength : SQLSMALLINT;
Datatype : SQLSMALLINT;
ColumnSize : SQLUINTEGER;
DecimalDigit : SQLSMALLINT;
Nullable : SQLSMALLINT;
begin

     GetHandle(hstmt,1);
     MemMove(@colnum,Sockfd.ParamStack[2].pbuff,sizeof(colnum));
     MemMove(@cnamemax,Sockfd.ParamStack[4].pbuff,sizeof(cnamemax));
     Sockfd.FuncResult :=
     SQLDescribeCol(hstmt,colnum,Sockfd.ParamStack[3].pbuff,
                    cnamemax,
                    NameLength,Datatype,ColumnSize,DecimalDigit,
                    Nullable);


     Sockfd.ParamStack[3].plen := NameLength+1;
     Sockfd.ParamStack[5].plen := sizeof(NameLength);
     MemMove(Sockfd.ParamStack[5].pbuff,@NameLength,sizeof(NameLength));
     Sockfd.ParamStack[6].plen := sizeof(Datatype);
     MemMove(Sockfd.ParamStack[6].pbuff,@Datatype,sizeof(Datatype));
     Sockfd.ParamStack[7].plen := sizeof(ColumnSize);
     MemMove(Sockfd.ParamStack[7].pbuff,@ColumnSize,sizeof(ColumnSize));
     Sockfd.ParamStack[8].plen := sizeof(DecimalDigit);
     MemMove(Sockfd.ParamStack[8].pbuff,@DecimalDigit,sizeof(DecimalDigit));
     Sockfd.ParamStack[9].plen := sizeof(Nullable);
     MemMove(Sockfd.ParamStack[9].pbuff,@Nullable,sizeof(Nullable));

end;


procedure callSQLBindCol;
var
hstmt : SQLHSTMT;
cno : SQLUSMALLINT;
dtype : SQLSMALLINT;
bufflen : SQLINTEGER;
i,j : integer;
sptr,stptr : Pchar;
ecode : SQLINTEGER;
slen : SQLSMALLINT;
begin


     GetHandle(hstmt,1);
     MemMove(@cno,Sockfd.ParamStack[2].pbuff,sizeof(cno));
     MemMove(@dtype,Sockfd.ParamStack[3].pbuff,sizeof(dtype));
     MemMove(@bufflen,Sockfd.ParamStack[5].pbuff,sizeof(bufflen));
      j := -1;
      j := GetDefaulttype(dtype);

      i := GetOldBind(hstmt,cno);
      if i = -1 then
      i := GetFreeBind;

      if (j > -1) and (bufflen =  0) then begin
      bufflen := j;
      boundcols[i].str := 0;
      end
      else
      if j = -1 then
      Boundcols[i].str := 1;

     if Sockfd.ParamStack[4].pbuff <> nil then
     begin
     MemMove(@(BoundCols[i].RemoteAddr),Sockfd.ParamStack[4].pbuff,
     sizeof(Pointer));

     BoundCols[i].MaxSize := bufflen;
     MemMove(@(BoundCols[i].RemoteLenAddr),Sockfd.ParamStack[6].pbuff,
     sizeof(pointer));

     GetMem(BoundCols[i].LocalPtr,bufflen+BoundCols[i].Str);
     BoundCols[i].colno := cno;
     BoundCols[i].hstmt := hstmt;
     end
     else
     begin
          boundcols[i].str := 0;
          i := GetLocalPtr(hstmt,cno);
          FreeMem(BoundCols[i].LocalPtr,BoundCols[i].MaxSize);
          BoundCols[i].MaxSize := 0;
          BoundCols[i].CurrSize := 0;
          BoundCols[i].RemoteAddr := nil;
          BoundCols[i].RemotelenAddr := nil;
          BoundCols[i].LocalPtr := nil;
          Boundcols[i].hstmt := 0;
          BoundCols[i].colno := 0;
     end;


     Sockfd.FuncResult :=
     SQLBindCol(hstmt,cno,dtype,BoundCols[i].LocalPtr,bufflen,
     BoundCols[i].Currsize);

     if Sockfd.FuncResult <> 0 then
     begin
          BoundCols[i].MaxSize := 0;
          BoundCols[i].CurrSize := 0;
          BoundCols[i].RemoteAddr := nil;
          BoundCols[i].RemotelenAddr := nil;
          BoundCols[i].LocalPtr := nil;
          Boundcols[i].hstmt := 0;
          BoundCols[i].colno := 0;
          BoundCols[i].Str := 0;

     end;

end;


procedure callSQLFetch;
var
hstmt : SQLHSTMT;
begin

     GetHandle(hstmt,1);
     Sockfd.FuncResult := SQLFetch(hstmt);
     Sockfd.hstmt := hstmt;

end;

procedure callSQLTables;
var
hstmt : SQLHSTMT;
nl1,nl2,nl3,nl4 : SQLSMALLINT;
s1,s2,s3,s4 : Pchar;
begin

     GetHandle(hstmt,1);
     MemMove(@nl1,Sockfd.ParamStack[3].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl2,Sockfd.ParamStack[5].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl3,Sockfd.ParamStack[7].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl4,Sockfd.ParamStack[9].pbuff,sizeof(SQLSMALLINT));



     Sockfd.FuncResult :=
     SQLTables(hstmt,
     Sockfd.ParamStack[2].pbuff,nl1,
     Sockfd.ParamStack[4].pbuff,nl2,
     Sockfd.ParamStack[6].pbuff,nl3,
     Sockfd.ParamStack[8].pbuff,nl4);

end;


procedure callSQLError;
var
henv : SQLHENV;
hdbc : SQLHDBC;
hstmt : SQLHSTMT;
nativeerror : SQLINTEGER;
NativeErrorptr : ^SQLINTEGER;
BufferLen : SQLSMALLINT;
TextLen : SQLSMALLINT;
TextLenptr : ^SQLSMALLINT;
TempBuff : Pchar;
begin

     GetMem(TempBuff,1024);

     textLen := -1;
     NativeError := -1;

      TextLenptr := Sockfd.ParamStack[8].pbuff;
      NativeErrorPtr := Sockfd.ParamStack[5].pbuff;

     GetHandle(henv,1);
     GetHandle(hdbc,2);
     GetHandle(hstmt,3);
     TextLen := -1;
     MemMove(@BufferLen,Sockfd.ParamStack[7].pbuff,sizeof(BufferLen));




     Sockfd.FuncResult := SQLError(henv,hdbc,hstmt,
     Sockfd.ParamStack[4].pbuff,
     NativeErrorPtr^,
     Tempbuff,
     1023,TextLenptr^);


     if (Sockfd.FuncResult > -1) and (Sockfd.FuncResult <> 100)
     and (Sockfd.ParamStack[4].pbuff <> nil)
     then
     Sockfd.ParamStack[4].plen := StrLen(Sockfd.ParamStack[4].pbuff)+1
     else
     Sockfd.ParamStack[4].plen := 0;


      if (Sockfd.FuncResult = 0) and
      (Sockfd.ParamStack[5].pbuff <> nil)
      then
     Sockfd.ParamStack[5].plen := sizeof(NativeError)
     else
     Sockfd.ParamStack[5].plen := 0;

     if (assigned(Sockfd.ParamStack[6].pbuff)) and (Sockfd.FuncResult = 0)
          and (Sockfd.ParamStack[6].pbuff <> nil)
         then begin
         StrCopy(Sockfd.ParamStack[6].pbuff,Tempbuff);
     Sockfd.ParamStack[6].plen := StrLen(Sockfd.ParamStack[6].pbuff)+1
     end
     else
     Sockfd.ParamStack[6].plen := 0;



      if (Sockfd.FuncResult = 0) and (TextLenPtr <> nil)  then
     Sockfd.ParamStack[8].plen := sizeof(TextLen)
     else
     Sockfd.paramStack[8].plen := 0;


     Form1.Memo1.Lines.clear;
     Form1.Memo1.Lines.Add(StrPas(tempbuff));

     FreeMem(tempbuff,1024);


end;



procedure callSQLGetFunctions;
var
hdbc : SQLHDBC;
fno : SQLUSMALLINT;
sint : Integer;

begin


     GetHandle(hdbc,1);
     MemMove(@fno,Sockfd.ParamStack[2].pbuff,sizeof(fno));
     Sockfd.FuncResult := SQLGetFunctions(hdbc,fno,
     Sockfd.ParamStack[3].pbuff);
     if fno = 0 then
     Sockfd.ParamStack[3].plen := 200
     else
     Sockfd.ParamStack[3].plen := 2;

     if Sockfd.ParamStack[3].plen = 2 then begin
     MemMove(@sint,Sockfd.ParamStack[3].pbuff,2);
     end;



end;


procedure callSQLTransact;
var
henv : SQLHENV;
hdbc : SQLHDBC;
ctype : SQLUSMALLINT;
begin

     GetHandle(henv,1);
     GetHandle(hdbc,2);
     MemMove(@ctype,Sockfd.ParamStack[3].pbuff,sizeof(SQLUSMALLINT));
     Sockfd.FuncResult := SQLTransact(henv,hdbc,ctype);


end;


procedure callSQLGetConnectOption;
var
hdbc : SQLHDBC;
opt : SQLUSMALLINT;
begin

     Gethandle(hdbc,1);
     MemMove(@opt,Sockfd.ParamStack[2].pbuff,sizeof(SQLSMALLINT));

     Sockfd.FuncResult := SQLGetConnectOption(hdbc,opt,
     Sockfd.paramStack[3].pbuff);
     if (opt = SQL_CURRENT_QUALIFIER) or
     (opt = SQL_OPT_TRACEFILE) or (opt = SQL_TRANSLATE_DLL) then
     Sockfd.ParamStack[3].plen := Strlen(Sockfd.ParamStack[3].pbuff)+1
     else
     Sockfd.ParamStack[3].plen := 4;



end;

procedure callSQLSetConnectOption;
var
hdbc : SQLHDBC;
opt : SQLUSMALLINT;
val : SQLUINTEGER;
begin

     Gethandle(hdbc,1);
     MemMove(@opt,Sockfd.ParamStack[2].pbuff,sizeof(SQLSMALLINT));
     MemMove(@val,Sockfd.ParamStack[3].pbuff,sizeof(SQLUINTEGER));
     Sockfd.FuncResult := SQLSetConnectOption(hdbc,opt,val);

end;




procedure callSQLDriverConnect;
var
hdbc : SQLHDBC;
strinlen,stroutlen,strmax,tlen : SQLSMALLINT;
tptr : Pchar;
pflag : SQLUSMALLINT;
begin

     Gethandle(hdbc,1);
     MemMove(@strinlen,Sockfd.ParamStack[4].pbuff,sizeof(SQLSMALLINT));
     MemMove(@strmax,Sockfd.ParamStack[6].pbuff,sizeof(SQLSMALLINT));

     if optform.checkbox1.checked then pflag := 1
     else
     pflag := 0;

     Sockfd.FuncResult :=
     SQLDriverConnect(hdbc,0,Sockfd.ParamStack[3].pbuff,strinlen,
     Sockfd.ParamStack[5].pbuff,strmax,stroutlen,pflag);

     MemMove(Sockfd.ParamStack[7].pbuff,@stroutlen,sizeof(SQLSMALLINT));
     Sockfd.ParamStack[7].plen := sizeof(SQLSMALLINT);
     Sockfd.ParamStack[5].plen := Stroutlen+1;



if Sockfd.FuncResult = 0 then
begin

     GetMem(tptr,1024);
     SQLGetInfo(hdbc,2,tptr,1023,tlen);
     Form1.Edit1.Text := StrPas(tptr);
     FreeMem(tptr,1024);
end;

end;





procedure callSQLColumns;
var
hstmt : SQLHSTMT;
nl1,nl2,nl3,nl4 : SQLSMALLINT;
begin

     GetHandle(hstmt,1);
     MemMove(@nl1,Sockfd.ParamStack[3].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl2,Sockfd.ParamStack[5].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl3,Sockfd.ParamStack[7].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl4,Sockfd.ParamStack[9].pbuff,sizeof(SQLSMALLINT));

     Sockfd.FuncResult := SQLColumns(hstmt,
     Sockfd.ParamStack[2].pbuff,nl1,
     Sockfd.ParamStack[4].pbuff,nl2,
     Sockfd.ParamStack[6].pbuff,nl3,
     Sockfd.ParamStack[8].pbuff,nl4);




end;


procedure callSQLSpecialColumns;
var
hstmt : SQLHSTMT;
Itype,Scope,Nullable : SQLUSMALLINT;
nl1,nl2,nl3 : SQLSMALLINT;
begin

     GetHandle(hstmt,1);
     MemMove(@nl1,Sockfd.ParamStack[4].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl2,Sockfd.ParamStack[6].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl3,Sockfd.ParamStack[8].pbuff,sizeof(SQLSMALLINT));
     MemMove(@Itype,Sockfd.ParamStack[2].pbuff,sizeof(SQLUSMALLINT));
     MemMove(@Scope,Sockfd.ParamStack[9].pbuff,sizeof(SQLUSMALLINT));
     MemMove(@Nullable,Sockfd.ParamStack[10].pbuff,sizeof(SQLUSMALLINT));

     Sockfd.FuncResult :=
     SQLSpecialColumns(hstmt,Itype,
     Sockfd.ParamStack[3].pbuff,nl1,
     Sockfd.ParamStack[5].pbuff,nl2,
     Sockfd.ParamStack[7].pbuff,nl3,
     Scope,Nullable);


end;


procedure callSQLColAttributes;
var
hstmt : SQLHSTMT;
colno,fid : SQLUSMALLINT;
slen,blen : SQLSMALLINT;
begin

     GetHandle(hstmt,1);
     MemMove(@colno,Sockfd.ParamStack[2].pbuff,sizeof(SQLUSMALLINT));
     MemMove(@fid,Sockfd.ParamStack[3].pbuff,sizeof(SQLUSMALLINT));
     MemMove(@blen,Sockfd.ParamStack[5].pbuff,sizeof(SQLSMALLINT));

     Sockfd.FuncResult :=
     SQLColAttributes(hstmt,colno,fid,Sockfd.ParamStack[4].pbuff,
     blen,slen,Sockfd.ParamStack[7].pbuff);

     if Sockfd.paramStack[4].pbuff <> nil then
     Sockfd.ParamStack[4].plen := Strlen(Sockfd.ParamStack[4].pbuff)+1
     else
     Sockfd.ParamStack[4].plen := 0;

     if Sockfd.paramStack[6].pbuff <> nil then begin
     MemMove(Sockfd.ParamStack[6].pbuff,@slen,sizeof(SQLSMALLINT));
     Sockfd.ParamStack[6].plen := sizeof(SQLSMALLINT);
     end
     else
     Sockfd.ParamStack[6].plen := 0;


     if Sockfd.paramStack[7].pbuff <> nil then
     Sockfd.ParamStack[7].plen := 4 {Pointer to 32 bits data value}
     else
     Sockfd.ParamStack[7].plen := 0;




end;



procedure callSQLStatistics;
var
Unique,Reserved : SQLUSMALLINT;
nl1,nl2,nl3 : SQLSMALLINT;
hstmt : SQLHSTMT;
begin

     GetHandle(hstmt,1);

     MemMove(@nl1,Sockfd.ParamStack[3].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl2,Sockfd.ParamStack[5].pbuff,sizeof(SQLSMALLINT));
     MemMove(@nl3,Sockfd.ParamStack[7].pbuff,sizeof(SQLSMALLINT));
     MemMove(@Unique,Sockfd.ParamStack[8].pbuff,sizeof(SQLUSMALLINT));
     MemMove(@Reserved,Sockfd.ParamStack[9].pbuff,sizeof(SQLUSMALLINT));

     Sockfd.FuncResult :=
     SQLStatistics(hstmt,
     Sockfd.ParamStack[2].pbuff,nl1,
     Sockfd.ParamStack[4].pbuff,nl2,
     Sockfd.ParamStack[6].pbuff,nl3,
     Unique,Reserved);


end;

procedure callSQLSetStmtOption;
var
hstmt : SQLHSTMT;
option : SQLUSMALLINT;
Value : SQLUINTEGER;
begin

     GetHandle(hstmt,1);
     MemMove(@Option,Sockfd.ParamStack[2].pbuff,sizeof(SQLUSMALLINT));
     MemMove(@Value,Sockfd.ParamStack[3].pbuff,sizeof(SQLUINTEGER));

     Sockfd.FuncResult := SQLSetStmtOption(hstmt,Option,Value);




end;


procedure callSQLGetStmtOption;
var
hstmt : SQLHSTMT;
option : SQLUSMALLINT;
Valueptr : SQLPOINTER;
Value : SQLINTEGER;
begin

     Valueptr := @Value;

     GetHandle(hstmt,1);
     MemMove(@Option,Sockfd.ParamStack[2].pbuff,sizeof(SQLUSMALLINT));
     Sockfd.FuncResult := SQLGetStmtOption(hstmt,Option,Valueptr);

     MemMove(Sockfd.ParamStack[3].pbuff,ValuePtr,sizeof(SQLUINTEGER));
     Sockfd.ParamStack[3].plen := sizeof(SQLUINTEGER);




end;


procedure callSQLExecDirect;
var
hstmt : SQLHSTMT;
tl : SQLINTEGER;
begin

     Gethandle(hstmt,1);
     MemMove(@tl,Sockfd.ParamStack[3].pbuff,sizeof(SQLINTEGER));
     Sockfd.FuncResult :=
     SQLExecDirect(hstmt,Sockfd.ParamStack[2].pbuff,tl);


end;



procedure callSQLRowCount;
var
hstmt : SQLHSTMT;
rc : SQLINTEGER;
begin

     Gethandle(hstmt,1);
     Sockfd.FuncResult := SQLRowCount(hstmt,rc);
     MemMove(Sockfd.ParamStack[2].pbuff,@rc,sizeof(SQLINTEGER));
     Sockfd.ParamStack[2].plen := sizeof(SQLINTEGER);

end;

procedure callSQLCancel;
var
hstmt : SQLHSTMT;
rc : SQLINTEGER;
begin

     Gethandle(hstmt,1);
     Sockfd.FuncResult := SQLCancel(hstmt);

end;


{    ============ Utility Functions ================   }

function GetOldBind(hstmt : SQLHSTMT ; cno : SQLUSMALLINT) : Integer;
var
i : integer;
found : boolean;
begin

     found := false;
     Result := -1;
     i := 1;
     while not(found) do
     begin

          if (BoundCols[i].hstmt = hstmt) and
          (BoundCols[i].colno = cno) then begin
          Result := i;
          found := true;
          end;
          Inc(i,1);
          if i > 512 then found := true;
     end;


end;


procedure Gethandle(var hdbc : SQLHDBC ; pno : integer);
begin
     MemMove(@hdbc,Sockfd.ParamStack[pno].pbuff,sizeof(hdbc));
end;

function GetRemoteAddr(LocalPtr : Pchar) : PChar;
var
i : integer;
found : boolean;
begin
     found := false;
     i := 1;
     while (not (found))  and (i < 513) do
     begin
          if LocalPtr = BoundCols[i].Localptr
          then
          begin
              found := true;
              Result := BoundCols[i].RemoteAddr;
          end
          else
          if BoundCols[i].RemoteAddr = nil then
          begin
             found := true;
             Result := nil;
          end
          else
          Inc(i,1);
     end;


end;


function GetFreeBind : Integer;
var
i : integer;
found : boolean;
begin

     i := 1;
     found := false;
     while (not (found)) and (i < 513) do begin

           if BoundCols[i].RemoteAddr = nil then
           begin
           found := true;
           Result := i;
           end
           else
           inc(i,1);
     end;
     if not found then
     Result := -1;

end;

function GetLocalPtr(hstmt : SQLHSTMT; cno : SQLUSMALLINT) : Integer;
var
i : integer;
found : boolean;
begin

     i := 1;
     found := false;
     while (not(found)) and (i < 513) do
     begin

          if (BoundCols[i].hstmt = hstmt) and (BoundCols[i].colno = cno)
          then
          begin
              Result := i;
              Found := true;
          end
          else
              Inc(i,1);
     end;

     if not found then
     Result := -1;
end;


function GetDefaultType(dt : SQLSMALLINT) : Integer;
begin

     case dt of
     1 : Result := -1; {char}
     2 : Result := -1; {numeric}
     3 : Result := -1; {Decimal}
     4 : Result := sizeof(longint); {Int}
     5 : Result := sizeof(integer); {Smallint}
     6 : Result := 8; {float (C double)}
     7 : Result := 8;  {Real}
     8 : Result := 8;  {Double}
     9 : Result := 6;  {Date}
     10: Result := 6;  {time}
     11: Result := 16; {timestamp}
     12: Result := -1; {Varchar}
     -1: Result := -1; {longvarchar}
     -2: Result := -1;
     -3: Result := -1;
     -4: Result := -1;
     -5: Result := -1; {bigint}
     -6: Result := 1;{tinyint}
     -7: Result := 1;{bit}




     end;

end;


procedure FreeColBinds( hstmt : SQLHSTMT);
var
i : Integer;
found : boolean;
begin

     found := false;
     i := 1;
     while not (found) do
     begin

          if (BoundCols[i].hstmt = hstmt)
          then
          begin
               if BoundCols[i].MaxSize > 0 then
               FreeMem(BoundCols[i].LocalPtr,BoundCols[i].MaxSize);
               BoundCols[i].MaxSize := 0;
               BoundCols[i].CurrSize := 0;
               BoundCols[i].RemoteAddr := nil;
               BoundCols[i].LocalPtr := nil;
               BoundCols[i].RemoteLenAddr := nil;
               BoundCols[i].hstmt := 0;
               BoundCols[i].str := 0;
               BoundCols[i].colno := 0;
          end;
          inc(i,1);
          if i > 512 then found := true;
     end;
end;


procedure UpdateColBuffs(hstmt : SQLHSTMT);
var
i,np,sint : Integer;
xxx,lint : longint;
found : boolean;
begin

     i:=1;
     np := 0;
     found := false;
     while (not(found)) do
     begin

     if(hstmt = BoundCols[i].hstmt ) and (BoundCols[i].MaxSize > 0)
     then
          begin
               MemMove(@xxx,@BoundCols[i].RemoteAddr,sizeof(longint));


               Sockfd.SendParam(0,
               BoundCols[i].Currsize+Boundcols[i].str,eUpdateBuff,
               xxx,0,BoundCols[i].LocalPtr);
               Sockfd.FuncResult := 1;

               MemMove(@xxx,@BoundCols[i].RemoteLenAddr,4);
               Sockfd.SendParam(1,
               sizeof(SQLINTEGER),eUpdateBuff,
               xxx,0,@(BoundCols[i].CurrSize));


               Inc(np,1);


          end;
     Inc(i,1);

      if i > 512 then
      found := true;



     end; { end while}

np := 0;


end;

function getinfotype(infotype : SQLUSMALLINT) : boolean;
begin
     Result := false;
     case infotype of
     SQL_ACCESSIBLE_PROCEDURES      : Result := true;
     SQL_ACCESSIBLE_TABLES          : Result := true;
     SQL_COLUMN_ALIAS               : Result := true;
     SQL_DATA_SOURCE_NAME           : Result := true;
     SQL_DATA_SOURCE_READ_ONLY      : Result := true;
     SQL_DATABASE_NAME              : Result := true;
     SQL_DBMS_NAME                  : Result := true;
     SQL_DBMS_VER                   : Result := true;
     SQL_DRIVER_NAME                : Result := true;
     SQL_DRIVER_ODBC_VER            : Result := true;
     SQL_DRIVER_VER                 : Result := true;
     SQL_EXPRESSIONS_IN_ORDERBY     : Result := true;
     SQL_IDENTIFIER_QUOTE_CHAR      : Result := true;
     SQL_KEYWORDS                   : Result := true;
     SQL_LIKE_ESCAPE_CLAUSE         : Result := true;
     SQL_MAX_ROW_SIZE_INCLUDES_LONG : Result := true;
     SQL_MULT_RESULT_SETS           : Result := true;
     SQL_MULTIPLE_ACTIVE_TXN        : Result := true;
     SQL_NEED_LONG_DATA_LEN         : Result := true;
     SQL_ODBC_SQL_OPT_IEF           : Result := true;
     SQL_ODBC_VER                   : Result := true;
     SQL_ORDER_BY_COLUMNS_IN_SELECT : Result := true;
     SQL_OUTER_JOINS                : Result := true;
     SQL_OWNER_TERM                 : Result := true;
     SQL_PROCEDURE_TERM             : Result := true;
     SQL_PROCEDURES                 : Result := true;
     SQL_QUALIFIER_NAME_SEPARATOR   : Result := true;
     SQL_QUALIFIER_TERM             : Result := true;
     SQL_ROW_UPDATES                : Result := true;
     SQL_SEARCH_PATTERN_ESCAPE      : Result := true;
     SQL_SERVER_NAME                : Result := true;
     SQL_SPECIAL_CHARACTERS         : Result := true;
     SQL_TABLE_TERM                 : Result := true;
     SQL_USER_NAME                  : Result := true;

     end;

end;



end .
