{
ODBConnect ODBC API Server source code. Version 1.0

                             By

                      Shahedali Moolji
                shahed@giasbm01.vsnl.net.in
             http://members.tripod.com/~shahed

This program and all its documentation is in the public domain.
You may do what you like with it !!.
My only request is for you not to remove this message.

If you find it to be of any interest, as a courtesy, please e-mail
me saying so. It would encourage me to continue to develop
such other s/w which may be of use to you in the future.

Special thanks to :-

Martin Diekhoff [ http://www.geniusworks.com ] without whose help &
encouragment, this would not have been possible.

Sajjad Lateef, for being a wonderful cousin and buying me all the s/w
that I needed for this project.

And to the dWinsock Team [Marc, Keith & Ulf ] for giving us dWinsock &
to the support list members for always being there when I needed them.

Thanks Guys !!

}





unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, dWinsock, sockio, odbc_api, StdCtrls, api, odbctype,
  DWSError, Menus, About, options;

type
  TForm1 = class(TForm)
    ServerSocket1: TServerSocket;
    Label1: TLabel;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    Help: TMenuItem;
    About: TMenuItem;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Memo1: TMemo;
    Edit3: TEdit;
    Label6: TLabel;
    File1: TMenuItem;
    Options1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ServerSocket1Accept(Sender: TObject; Socket: TSocketBase);
    procedure ServerSocket1Read(Sender: TObject; Socket: TSocketBase);
    procedure ServerSocket1Write(Sender: TObject; Socket: TSocketBase);
    procedure ServerSocket1Disconnect(Sender: TObject;
      Socket: TSocketBase);
    procedure AboutClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Sockfd : TSocketio;

procedure ActionBlock (fcode : integer);
procedure ShowStatus(hstate : TSockState ; fno : integer);
procedure MemMove(dest,src : PChar ; Len : Longint);
implementation
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
i : integer;
begin

     ServerSocket1.Listen(TStreamSocket);
     Sockfd := TSocketio.Create;

     for i := 1 to 512 do
     begin
          BoundCols[i].hstmt := 0;
          BoundCols[i].colno := 0;
          Boundcols[i].Localptr := nil;
          BoundCols[i].RemoteAddr := nil;
          BoundCols[i].RemoteLenAddr := nil;
          BoundCols[i].MaxSize := 0;
          BoundCols[i].CurrSize := 0;
          BoundCols[i].Str := 0;

     end;
end;





procedure TForm1.ServerSocket1Accept(Sender: TObject; Socket: TSocketBase);
begin

     Form1.Label2.Font.Color := clRed;
     Form1.Label2.Caption := 'Connected to '+Socket.RemoteAddress;
     Sockfd.RegisterSocket((Socket as TStreamSocket));
     Sockfd.RegisterExecProc(ActionBlock);
     Sockfd.RegisterStatusProc(ShowStatus);
     Sockfd.RegisterColUpdtProc(UpdateColBuffs);
end;

procedure TForm1.ServerSocket1Read(Sender: TObject; Socket: TSocketBase);
begin
Sockfd.ProcessRead;
end;

procedure TForm1.ServerSocket1Write(Sender: TObject; Socket: TSocketBase);
begin
Sockfd.ProcessWrite;
end;


procedure ActionBlock(fcode : integer);
begin


     case fcode of

     fSQLAllocEnv          : callSQLAllocEnv;
     fSQLAllocConnect      : callSQLAllocConnect;
     fSQLConnect           : callSQLConnect;
     fSQLDisconnect        : callSQLDisconnect;
     fSQLFreeConnect       : callSQLFreeConnect;
     fSQLFreeEnv           : callSQLFreeEnv;
     fSQLGetInfo           : callSQLGetInfo;
     fSQLAllocStmt         : callSQLAllocStmt;
     fSQLFreeStmt          : callSQLFreeStmt;
     fSQLGetTypeInfo       : callSQLGetTypeInfo;
     fSQLNumResultCol      : callSQLNumResultCol;
     fSQLDescribeCol       : callSQLDescribeCol;
     fSQLBindCol           : callSQLBindCol;
     fSQLFetch             : callSQLFetch;
     fSQLTables            : callSQLTables;
     fSQLError             : callSQLError;
     fSQLGetFunctions      : callSQLGetFunctions;
     fSQLTransact          : callSQLTransact;
     fSQLGetConnectOption  : callSQLGetConnectOption;
     fSQLSetConnectOption  : callSQLSetConnectOption;
     fSQLDriverConnect     : callSQLDriverConnect;
     fSQLColumns           : callSQLColumns;
     fSQLSpecialColumns    : callSQLSpecialColumns;
     fSQLColAttributes     : callSQLColAttributes;
     fSQLStatistics        : callSQLStatistics;
     fSQLSetStmtOption     : callSQLSetStmtOption;
     fSQLGetStmtOption     : callSQLGetStmtOption;
     fSQLExecDirect        : callSQLExecDirect;
     fSQLRowCount          : callSQLRowCount;
     fSQLCancel            : callSQLCancel;
     end;


end;





procedure TForm1.ServerSocket1Disconnect(Sender: TObject;
  Socket: TSocketBase);
begin
Form1.Label2.Font.Color := clBlue;
Form1.Label2.Caption := 'Waiting for Connection ';

try
Socket.Close;
except
begin
     showmessage('Server Socket Error : ');
end;
end;

Sockfd.free;
Sockfd := TSocketIO.Create;

end;



procedure MemMove(dest,src : PChar ; Len : Longint);
var
i : integer;
begin

     for i := 0 to Len - 1 do
     (dest+i)^ := (src+i)^;

end;



procedure ShowStatus(hstate : TSockState ; fno : integer);
begin


     case hstate of

     FuncHeader       :
     begin
     Form1.Edit2.Text := GetFuncName(fno);
     Form1.Edit3.Text := 'Receving Function Header';
     end;
     FuncDone         : begin
     Form1.Edit2.Text := '';Form1.Edit3.Text := '';end;
     ParamHeader      : Form1.Edit3.Text := 'Receving Parameter Data';
     FuncAck          : Form1.Edit3.Text := 'Receving Ack';
     FuncAskParam     : Form1.Edit3.Text := 'Returning Parameter Data';
     FuncUpdateCols   : Form1.Edit3.Text := 'Updating Remote Data Buffers';
     end;

end;

procedure TForm1.AboutClick(Sender: TObject);
begin

     AboutBox.ShowModal;

end;

procedure TForm1.Options1Click(Sender: TObject);
begin
optform.showmodal;
end;

end.
